package fi.aalto.control.server;

import com.prosysopc.ua.stack.builtintypes.UnsignedInteger;
import com.prosysopc.ua.server.UaServer;
import com.prosysopc.ua.stack.builtintypes.NodeId;
import com.prosysopc.ua.nodes.UaNode;
import com.prosysopc.ua.nodes.UaValueNode;

public class ControlSimulation implements Runnable {
	
	double x = 0;
	double y = 0;
	boolean exit = false;
	UaServer server;
	
	public ControlSimulation (UaServer server) {
		super();
		this.server = server;
	}
	
	public void run() {
		
	    try {
	    	Thread.sleep(500);
	    	
	    	UaValueNode yNode = (UaValueNode)server.getNodeManagerRoot().getNode(new NodeId(2, "P300_MeasVal"));		    
	    	UaValueNode uNode = (UaValueNode)server.getNodeManagerRoot().getNode(new NodeId(2, "M200_CurCtrlVal"));		    
	    	UaValueNode KpNode = (UaValueNode)server.getNodeManagerRoot().getNode(new NodeId(2, "PIC300_Kp"));		    
	    	UaValueNode spNode = (UaValueNode)server.getNodeManagerRoot().getNode(new NodeId(2, "PIC300_SPVal"));		    
		    
	    	float Kp = KpNode.getValue().getValue().floatValue();
	    	float sp = spNode.getValue().getValue().floatValue();
	    	float y, e, u;
	    	
		    while (!exit) {		    	
		    	y = yNode.getValue().getValue().floatValue();
		    	e = sp - y;
		    	u = Kp * e;
		    	//System.out.println(sp + " " + y + " " + e + " " + u);
		    	uNode.setValue(new Float(u));
		        Thread.sleep(100);
		    }
		} catch (Exception e) {
				System.out.println(e.getMessage());
		}
	}
	
	public void stop() {
		exit = true;
	}
}